"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.shouldForceBrowserRuntimeInNode = void 0;
function isNodeRuntime() {
    var _a;
    return typeof process !== 'undefined' && Boolean((_a = process === null || process === void 0 ? void 0 : process.versions) === null || _a === void 0 ? void 0 : _a.node);
}
var shouldForceBrowserRuntimeInNode = function () {
    var _a;
    if (!isNodeRuntime())
        return false;
    var isArm64 = process.arch === 'arm64';
    var isNode20 = process.version.startsWith('v20');
    var hasNoNodeSnapshotNodeOption = (_a = process.env.NODE_OPTIONS) === null || _a === void 0 ? void 0 : _a.includes('--no-node-snapshot');
    if (isArm64 && isNode20 && !hasNoNodeSnapshotNodeOption) {
        console.log("Skipping usage of `isolated-vm` to avoid crashes in Node v20 on an arm64 machine.\n    If you would like to use the `isolated-vm` package on this machine, please provide the `NODE_OPTIONS=--no-node-snapshot` config to your Node process.\n    See https://github.com/BuilderIO/builder/blob/main/packages/react/README.md#node-v20--m1-macs-apple-silicon-support for more information.\n    ");
        return true;
    }
    return false;
};
exports.shouldForceBrowserRuntimeInNode = shouldForceBrowserRuntimeInNode;
//# sourceMappingURL=should-force-browser-runtime-in-node.js.map